import RPi.GPIO as GPIO
import time
GPIO.setmode(GPIO.BCM)
GPIO.setwarnings( 0 )

print( "hc595 walk" )

shift_clock_pin = 17  # let op de pinnen zijn aangepast!
latch_clock_pin = 27
data_pin = 22

GPIO.setup( shift_clock_pin, GPIO.OUT )
GPIO.setup( latch_clock_pin, GPIO.OUT )
GPIO.setup( data_pin, GPIO.OUT )

def hc595( shift_clock_pin, latch_clock_pin, data_pin, value, delay ):

    for k in range(0, 8): # 8 keer loopen
        if value % 2 == 1:  # als waarde oneven is
            GPIO.output(data_pin, GPIO.HIGH)  # data pin hoog zetten
        else:  # waarde is even
            GPIO.output(data_pin, GPIO.LOW)  # data pin laag houden
        value = value // 2  # waarde halveren

        GPIO.output(shift_clock_pin, GPIO.HIGH)  # klok hoog, om de waarde pin te laten aflezen
        GPIO.output(shift_clock_pin, GPIO.LOW)  # klok laag, default positie


    GPIO.output(latch_clock_pin, GPIO.HIGH)  # geen idee, waarschijnlijk om de waardes op te laten slaan in de chip
    GPIO.output(latch_clock_pin, GPIO.LOW)  # default positie
    time.sleep(delay)





delay = 0.1
try:
    while True:
        hc595( shift_clock_pin, latch_clock_pin, data_pin,   1, delay )  # waarde is 1 dus de eerste led hoort te branden de rest niet
        hc595( shift_clock_pin, latch_clock_pin, data_pin,   2, delay )  # waarde is 2 dus de tweede led en niet de 1e hoort te branden
        hc595( shift_clock_pin, latch_clock_pin, data_pin,   4, delay )  # waarde is 4 dus de 3e led hoort te branden de rest niet
        hc595( shift_clock_pin, latch_clock_pin, data_pin,   8, delay )  # enzovoort
        hc595( shift_clock_pin, latch_clock_pin, data_pin,  16, delay )
        hc595( shift_clock_pin, latch_clock_pin, data_pin,  32, delay )
        hc595( shift_clock_pin, latch_clock_pin, data_pin,  64, delay )
        hc595( shift_clock_pin, latch_clock_pin, data_pin, 128, delay )  # de 8e led en niet meer
except KeyboardInterrupt:
    GPIO.cleanup()